#include "stdafx.h"
#include "Assert.h"

#if ASSERTS_IMPLEMENTED

__declspec(noinline) bool AssertImpl( bool cond, const char* strFile, const char* strFuncName, int iLine, const char* pstrFormat, ... )
{
    if( cond )
        return true;
    va_list args;
    va_start(args, pstrFormat);
    CStringA strMessage;
    strMessage.FormatV(pstrFormat, args);
    va_end(args);

    // trap to a debugger before the ATLTRACE.
    // So if the process was not debugged before, the developer will see ATLTRACE-d message anyway
    // just after he presses the "press cancel to debug", then 'F10' x 2.
    __debugbreak();
    ATLTRACE( "Assertion failure in file %s, line %d, func %s:\n%s\n",
        strFile, iLine, strFuncName, (const char*)(strMessage) );
    return false;
}

#endif