#include "StdAfx.h"
#include "DxWnd.h"

LRESULT CDxWnd::OnCreate( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
    bHandled = false;

	HRESULT hr = InitD3D();
	if(FAILED(hr))
		return -1;

//    ASSERT( false == m_bSessionNotificationRegistered, "WM_CREATE happened more then once?" );
//    m_bSessionNotificationRegistered = WTSRegisterSessionNotification( m_hWnd, NOTIFY_FOR_THIS_SESSION ) ? true: false;
//    ASSERT( m_bSessionNotificationRegistered,
//        "WTSRegisterSessionNotification failed:\n%S", LPCTSTR(ErrorMessage(GetLastHr())));
	return 0;
}

LRESULT CDxWnd::OnDestroy( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
    bHandled = false;

    DestroyResources();
    ReleaseComPtr( m_pDev );
    ReleaseComPtr( m_pD3D );

//    if( m_bSessionNotificationRegistered )
//        WTSUnRegisterSessionNotification( m_hWnd );
	return 0;
}

LRESULT CDxWnd::OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if( false == m_bSuppressDeviceOperations )
		DoDrawScene();
	ValidateRect( NULL );
	return 0;
}

LRESULT CDxWnd::OnGetMinMaxInfo( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	MINMAXINFO* pMMI = reinterpret_cast<MINMAXINFO*>( lParam );
	pMMI->ptMinTrackSize = s_MinTrackSize;
	return 0;
}

LRESULT CDxWnd::OnSize( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
    bHandled = false;

	switch( wParam )
	{
	case SIZE_MAXIMIZED:
	case SIZE_RESTORED:
		m_bSuppressDeviceOperations = false;
		if( NULL == m_pDev )
			return 0;
		break;
	case SIZE_MINIMIZED:
		m_bSuppressDeviceOperations = true;
	default:
		return 0;
	}

	if( false == m_bSuppressDeviceOperations )
    {
        CSize sz((DWORD)(lParam));
        m_DevParams.BackBufferWidth = sz.cx;
        m_DevParams.BackBufferHeight = sz.cy;
        DoReset();
    }

	return 0;
}
/*
LRESULT CDxWnd::OnSysKeyDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	if( false == m_bSuppressDeviceOperations && VK_RETURN == wParam && (DWORD(lParam) & 0x20000000 ) ) // Alt+Enter
	{
		bHandled = TRUE;
		if( m_DevParams.Windowed )
		{
			m_DevParams.Windowed = FALSE;
			m_pDev->Clear(0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, m_ClearColor, 1.0f, 0);
			m_pDev->Present( NULL, NULL, NULL, NULL );
			GetWindowRect(&m_WindowRect);
			DoReset();
		}
		else
		{
			m_DevParams.Windowed = TRUE;
			SetCursor( LoadCursor( NULL, IDC_WAIT ) );
			m_pDev->Clear( 0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, m_ClearColor, 1.0f, 0 );
			m_pDev->Present( NULL, NULL, NULL, NULL );
			DoReset();
			SetWindowPos( HWND_TOP, &m_WindowRect, 0 );
			SetCursor( LoadCursor( NULL, IDC_ARROW ) );
		}
		return 0;
	}
	bHandled = FALSE;
	return 0;
}

LRESULT CDxWnd::OnWtsSessionChange( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
    ATLTRACE("CDxWnd::OnWtsSessionChange\n");
    return 0;
}
*/