#pragma once
#include "VsTabs/TabsOwner.h"

#include "ViewWindows/GdiViewWnd.h"
#include "ViewWindows/IeView.h"
#include "viewwindows/Direct3DView.h"
#include "Utils/ImageWnd.h"

#include "Utils/DocHostHandler.h"

class CMainWnd:
	public CWindowImpl< CMainWnd, CWindow, CFrameWinTraits >,
	public NVsTabs::CTabsOwner
{
public:
	CMainWnd( void );
	~CMainWnd( void );

	DECLARE_WND_CLASS_EX( L"MainWnd", CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, COLOR_APPWORKSPACE )

	BEGIN_MSG_MAP( CMainWnd )
		MESSAGE_HANDLER( WM_SIZE, OnSize )
		MESSAGE_HANDLER( WM_CREATE, OnCreate )
		MESSAGE_HANDLER( WM_DESTROY, OnDestroy )
        MESSAGE_HANDLER( WM_SETFOCUS, bHandled = PassFocusToActiveView();__noop )

//		COMMAND_ID_HANDLER( ID_FILE_NEW_GDITEST, OnCmdNewGditest )
//		COMMAND_ID_HANDLER( ID_FILE_NEW_IE, OnCmdNewIe )

		COMMAND_ID_HANDLER( ID_FILE_NEW_GDITEST, OnNewView<CGdiViewWnd> )
		COMMAND_ID_HANDLER( ID_FILE_NEW_IE, OnNewView<CIeViewWnd> )
        COMMAND_ID_HANDLER( ID_FILE_NEW_D3D, OnNewView<CBubblesWnd> )
		COMMAND_ID_HANDLER( ID_FILE_NEW_IMGTEST, OnNewView<CImageWnd> )

		// For Ctrl+F4, Ctrl+Tab, Ctrl+Shift+Tab accelerators.
		CHAIN_MSG_MAP( NVsTabs::CTabsOwner )
	END_MSG_MAP()

	HRESULT Create( int iCmdShow );

	bool OnIdle();
private:
	LRESULT OnCreate( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );
	LRESULT OnDestroy( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );
	LRESULT OnSize( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );
//    LRESULT OnFocus( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );

	template<typename TView>
	LRESULT OnNewView( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );
//    LRESULT OnCmdNewGditest( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );
//	LRESULT OnCmdNewIe( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );
	
	LRESULT OnCmdAbout( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );

	// 2 overridables from CTabsOwner, to correctly position both tab panel and view windows.
	virtual CRect GetTabsRect();
	virtual CRect GetViewRect();

	CRect GetEffectiveClientRect() const;

	static const UINT idStatus = 2001;
	static const UINT idTabs = 2002;

	CWindow m_wndStatus;

	CMyDocHostHandler m_docHostHandler;
};