#pragma once
#include "../resource.h"

#include "wtl/atlapp.h"
#include "wtl/atlcrack.h"
#include "wtl/atlctrls.h"

__interface IBubbleSettings;

class CBubbleSettingsWnd:
    public CDialogImpl< CBubbleSettingsWnd >    // Use CAeroDialogImpl instead?
{
public:
    enum { IDD = IDD_BUBBLES_PROPERTIES };

    CBubbleSettingsWnd();
    ~CBubbleSettingsWnd();

    BEGIN_MSG_MAP( CBubbleSettingsWnd )
        MSG_WM_INITDIALOG( OnInitDialog )

//        COMMAND_HANDLER( IDC_LEFTCLICK, CBN_CLOSEUP, OnButtonsBindingsChanged )
//        COMMAND_HANDLER( IDC_RIGHTCLICK, CBN_CLOSEUP, OnButtonsBindingsChanged )

//        COMMAND_HANDLER_EX( IDC_PAINT_SAME, BN_CLICKED, PaintBubblesSame )
//        COMMAND_HANDLER_EX( IDC_PAINT_RANDOM, BN_CLICKED, PaintBubblesRandom )
//        COMMAND_HANDLER_EX( IDC_PAINT_DOMAINS, BN_CLICKED, PaintBubblesDomains )

//        COMMAND_HANDLER_EX( IDC_HIGHLITE, CBN_SELCHANGE, OnHighliteCloseup )

		COMMAND_HANDLER_EX( IDC_COLOR_MODE, CBN_SELCHANGE, OnSomethingChanged );
		COMMAND_HANDLER_EX( IDC_HIGHLITE, CBN_SELCHANGE, OnSomethingChanged );

        MSG_WM_WINDOWPOSCHANGED( OnWindowPosChanged )
		MSG_WM_CAPTURECHANGED( OnCaptureChanged )

        COMMAND_HANDLER_EX( IDC_HIDE_THIS, BN_CLICKED, ShowHideWholePanel(false);__noop )
    END_MSG_MAP();

    HRESULT Create( CWindow* pWndParent, IBubbleSettings* pBubbles );

    void ShowHideWholePanel( bool bShow );
private:
    BOOL OnInitDialog( CWindow wndFocus, LPARAM lInitParam );

    void OnWindowPosChanged( LPWINDOWPOS lpWndPos );
	void OnCaptureChanged( CWindow wnd );
/*
    LRESULT OnButtonsBindingsChanged( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled );

    void PaintBubblesSame( UINT uNotifyCode, int nID, CWindow wndCtl );
    void PaintBubblesRandom( UINT uNotifyCode, int nID, CWindow wndCtl );
    void PaintBubblesDomains( UINT uNotifyCode, int nID, CWindow wndCtl );

    void OnHighliteCloseup( UINT uNotifyCode, int nID, CComboBoxT<CWindow> wndCtl );
*/
    IBubbleSettings* m_pBubbles;

	CComboBoxT<CWindow> m_cbColor, m_cbHighlite;

	BOOL UpdateData( BOOL bSaveAndValidate );

	inline void OnSomethingChanged( UINT uNotifyCode, int nID, CComboBoxT<CWindow> wndCtl )
	{
		UpdateData( TRUE );
	}
//    CComboBoxT<CWindow> m_cbLeftClick, m_cbRightClick, m_cbHighlite;
};