#include "stdafx.h"
#include "DocHostHandler.h"

// This COM class implements the IDocHostUIHandlerDispatch interface for the IE ActiveX
class CDocHostHandler:
    public CComObjectRootEx<CComSingleThreadModel>,
    public IDispatchImpl<IDocHostUIHandlerDispatch>
{
public:
    inline CDocHostHandler(){}
    inline ~CDocHostHandler(){}

    BEGIN_COM_MAP(CDocHostHandler)
        COM_INTERFACE_ENTRY(IDispatch)
        COM_INTERFACE_ENTRY(IDocHostUIHandlerDispatch)
    END_COM_MAP()
protected:
    // IDocHostUIHandlerDispatch methods
    virtual HRESULT STDMETHODCALLTYPE ShowContextMenu( DWORD dwID, DWORD x, DWORD y,
        IUnknown *pcmdtReserved, IDispatch *pdispReserved, HRESULT *dwRetVal)
    {
        *dwRetVal = S_OK;
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE GetHostInfo(DWORD *pdwFlags, DWORD *pdwDoubleClick)
    {
        *pdwFlags = DOCHOSTUIFLAG_DISABLE_HELP_MENU;
        *pdwDoubleClick = DOCHOSTUIDBLCLK_DEFAULT;
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE ShowUI(DWORD dwID, IUnknown *pActiveObject,
        IUnknown *pCommandTarget, IUnknown *pFrame, IUnknown *pDoc, HRESULT *dwRetVal)
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE HideUI()
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE UpdateUI()
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE EnableModeless(VARIANT_BOOL fEnable)
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE OnDocWindowActivate(VARIANT_BOOL fActivate)
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE OnFrameWindowActivate(VARIANT_BOOL fActivate)
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE ResizeBorder(long left, long top, long right, long bottom,
        IUnknown *pUIWindow, VARIANT_BOOL fFrameWindow)
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE TranslateAccelerator(DWORD_PTR hWnd, DWORD nMessage,
        DWORD_PTR wParam, DWORD_PTR lParam, BSTR bstrGuidCmdGroup, DWORD nCmdID, HRESULT *dwRetVal)
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE GetOptionKeyPath(BSTR *pbstrKey, DWORD dw)
    {
        return S_OK;
    }

    virtual HRESULT STDMETHODCALLTYPE GetDropTarget(IUnknown *pDropTarget, IUnknown **ppDropTarget)
    {
        *ppDropTarget = NULL;
        return E_NOTIMPL;
    }

    virtual HRESULT STDMETHODCALLTYPE GetExternal(IDispatch **ppDispatch)
    {
        *ppDispatch = NULL;
        return S_FALSE;
    }

    virtual HRESULT STDMETHODCALLTYPE TranslateUrl(DWORD dwTranslate, BSTR bstrURLIn, BSTR *pbstrURLOut)
    {
        *pbstrURLOut = NULL;
        return S_FALSE;
    }

    virtual HRESULT STDMETHODCALLTYPE FilterDataObject(IUnknown *pDO, IUnknown **ppDORet)
    {
        *ppDORet = NULL;
        return S_FALSE;
    }
};

CMyDocHostHandler* CMyDocHostHandler::s_pThis = NULL;

IDocHostUIHandlerDispatch* CMyDocHostHandler::GetDocHostHandler()
{
    ASSERT( NULL != s_pThis, "You must explicitly construct exactly one instance of CMyDocHostHandler class." );

    if( s_pThis->m_pDoc )
        return s_pThis->m_pDoc;

    CComObject<CDocHostHandler>* pObj;
    HRESULT hr = CComObject<CDocHostHandler>::CreateInstance( &pObj );
    CHECK( SUCCEEDED(hr), return NULL,
        "CComObject<CDocHostHandler>::CreateInstance failed.\n%S", LPCTSTR(ErrorMessage(hr)) );
    pObj->AddRef();
    s_pThis->m_pDoc.Attach( pObj );
    return s_pThis->m_pDoc;
}
