#include "stdafx.h"
#include "GdiResources.h"
#include "../resource.h"

CGdiResources::Resources::Resources()
{
	ZeroMemory( this, sizeof(*this) );
}

size_t CGdiResources::m_sInitCount = 0;
CGdiResources::Resources CGdiResources::m_sResources;

CGdiResources::CGdiResources()
{
	m_bInitDone = false;
}

HRESULT CGdiResources::Create()
{
	if( m_bInitDone )
		return S_FALSE;

	if( m_sInitCount == 0 )
	{
		const HRESULT hr = m_sResources.Create();
		if( FAILED( hr ) )
			return hr;
	}
	m_sInitCount++;
	m_bInitDone = true;
	return S_OK;
}

CGdiResources::~CGdiResources()
{
	ASSERT( m_sInitCount > 0, "Instance counter inconsistency" );
	if( !m_bInitDone )
		return;
	m_sInitCount--;
	if( 0 == m_sInitCount )
		m_sResources.Destroy();
}

HRESULT CGdiResources::Resources::Create()
{
	// Create a background brush.
	hTranspBrushBitmap = LoadBitmap( _AtlBaseModule.GetModuleInstance(), MAKEINTRESOURCE( IDB_TRANSPARENTBRUSH ) );
	if(NULL == hTranspBrushBitmap)
		return GetLastHr();
	hTransparencyBrush = CreatePatternBrush( hTranspBrushBitmap );
	if(NULL == hTransparencyBrush)
		return GetLastHr();

	curHand = LoadCursor( NULL, MAKEINTRESOURCE( IDC_HAND ) );
	curArrow = LoadCursor( NULL, MAKEINTRESOURCE( IDC_ARROW ) );

	curSizeAll = LoadCursor( NULL, MAKEINTRESOURCE( IDC_SIZEALL ) );
	curSizeV = LoadCursor( NULL, MAKEINTRESOURCE( IDC_SIZENS ) );
	curSizeH = LoadCursor( NULL, MAKEINTRESOURCE( IDC_SIZEWE ) );

	return S_OK;
}

HRESULT CGdiResources::Resources::Destroy()
{
	DeleteObject(hTransparencyBrush);
	DeleteObject(hTranspBrushBitmap);
	// There's no need to destroy the
	return S_OK;
}