// VSTabsDemo.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "VSTabsDemo.h"
#include "MainWnd.h"

int APIENTRY _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow )
{
    HRESULT hr = CoInitialize( NULL );
    if( FAILED( hr ) )
    {
		ReportError( NULL, MB_ICONERROR, hr, L"CoInitialize() failed." );
        return 0;
    }

    static CComModule _Module;
    _pAtlModule = &_Module;

    RUN_UNIT_TESTS( lpCmdLine );

	CMainWnd w;
	hr = w.Create( nCmdShow );
	if(FAILED(hr))
    {
		// Most likely the user already saw a message box displayed from within the CMainWnd::OnCreate before it returned (-1).
		ReportError( NULL, MB_ICONERROR, hr, L"CMainWnd::Create() failed." );
        CoUninitialize();
        return 0;
    }

    HACCEL haccel = LoadAccelerators( _AtlBaseModule.GetModuleInstance(), MAKEINTRESOURCE(IDC_ACCEL_VSTABSDEMO) );
	MSG msg;
	do 
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) != 0 )
		{
			if( !TranslateAccelerator( w.m_hWnd, haccel, &msg ) )
			{
			    TranslateMessage( &msg );
			    DispatchMessage( &msg );
			}
		}
		else
		{
			// No messages 2 process?
			msg.message = WM_NULL;
			if( !w.OnIdle() )
				Sleep(1);
		}
	}
	while( WM_QUIT != msg.message );

    CoUninitialize();
	return (int) msg.wParam;
}