#pragma once
#include "../VsTabs/TabViewImpl.hpp"

// GDI Demo View, it only paints 4 gradient triangles of random colors.
class CGdiViewWnd:
	public NVsTabs::CTabViewWindowImpl< CGdiViewWnd >
{
public:
	CGdiViewWnd( NVsTabs::CTabsOwner* pOwner );
	virtual ~CGdiViewWnd();

	HRESULT Create( CWindow* pParent );

	// Since this window paints the whole client area, we don't need to erase the background.
	// So we pass NULL to hbrBackground to disable WM_ERASEBKGND handling by DefWindowProc()
	DECLARE_WND_CLASS_EX( L"GdiViewWnd", CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS, -1 )

	BEGIN_MSG_MAP( CGdiViewWnd )
		CHAIN_MSG_MAP( TTabViewImpl )
		MESSAGE_HANDLER( WM_SIZE, OnSize )
		MESSAGE_HANDLER( WM_PAINT, OnPaint )
	END_MSG_MAP()
protected:
	LRESULT OnSize( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );
	LRESULT OnPaint( UINT nMsg, WPARAM wParam,  LPARAM lParam, BOOL& bHandled );

	TRIVERTEX          m_vertexbuf[5];
	GRADIENT_TRIANGLE  m_indexbuf[4];
};
