#include "StdAfx.h"
#include "IeView.h"
#include "../Utils/DocHostHandler.h"

//using NVsTabs;
CIeViewWnd::CIeViewWnd( NVsTabs::CTabsOwner* pOwner ):
	CTabViewWindowImpl<CIeViewWnd>( pOwner )
{
	
}

CIeViewWnd::~CIeViewWnd()
{

}

HRESULT CIeViewWnd::Create( CWindow* pParent )
{
	static int iSN = 1;
	CString strName;
	strName.Format( L"IE View #%i", iSN );
	iSN++;

	HWND w = __super::Create( pParent->m_hWnd, NULL, strName );
	if( NULL == w )
		return GetLastHr();
	return S_OK;
}

LRESULT CIeViewWnd::OnCreate( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	HWND w = m_ie.Create( m_hWnd, NULL, NULL, WS_CHILD | WS_VISIBLE );
	if( NULL == w )
		return -1;

//	LPCTSTR strName = L"MSHTML:<HTML><BODY>This is a line of text</BODY></HTML>";
//	LPCTSTR strName = L"http://msdn.microsoft.com/en-us/library/default.aspx";
	HRESULT hr = m_ie.CreateControl( IDR_HTML1 );
	if(FAILED(hr))
		return -1;

	hr = m_ie.SetExternalUIHandler( CMyDocHostHandler::GetDocHostHandler() );
	if(FAILED(hr))
		return -1;

	return 0;
}

LRESULT CIeViewWnd::OnSize( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	if( m_ie.m_hWnd && m_ie.IsWindow() )
	{
		CRect rc;
		GetClientRect(&rc);
		m_ie.MoveWindow(&rc);
	}
	return 0;
}

LRESULT CIeViewWnd::OnSetFocus( UINT nMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	m_ie.SetFocus();
	return 0;
}