#include <stdafx.h>
#include "TabsOwner.h"

using namespace NVsTabs;

CTabsOwner::CTabsOwner()
{
	m_pActiveView = NULL;
}

HRESULT CTabsOwner::Create( CWindow* pParent, UINT uID )
{
	return m_wndTabs.Create( pParent, this, uID );
}

DWORD CTabsOwner::CreateTab( CWindow* pView )
{
	CString strText;
	pView->GetWindowText( strText );
	return m_wndTabs.AddTab( strText, pView );
}

void CTabsOwner::DestroyTab( DWORD dwTabId )
{
	m_wndTabs.RemoveTab( dwTabId );
}

void CTabsOwner::UpdateTabCaption( DWORD dwID )
{
	CWindow* const pView = GetView( dwID );
	CString strText;
	pView->GetWindowText( strText );
	m_wndTabs.SetTabText( dwID, strText );
}

void CTabsOwner::OnTabSwitched( DWORD dwTabID )
{
	if(!dwTabID) // It wast the last tab
	{
		m_pActiveView = NULL;
//		SetFocus();
		return;
	}

	CWindow* pView = GetView( dwTabID );

	// Hide the old view
	if( NULL != m_pActiveView )
		m_pActiveView->ShowWindow( SW_HIDE );
	if( NULL == pView || pView == m_pActiveView )
		return;

	// Show the new one
	m_pActiveView = pView;
	m_pActiveView->MoveWindow( GetViewRect(), FALSE );
	m_pActiveView->ShowWindow( SW_SHOW );
	m_pActiveView->SetFocus();
}

void CTabsOwner::OnTabContextMenu( DWORD dwTabID, CPoint pt )
{
	AtlTrace("CTabsOwner::OnTabContextMenu( dwTabID=%i )\n", int(dwTabID) );
}

void CTabsOwner::OnTabClose( DWORD dwTabID )
{
    CWindow* pView = GetView( dwTabID );
    if( NULL != pView )
        pView->SendMessage( WM_CLOSE );
}

void CTabsOwner::Resize()
{
	if( m_wndTabs.m_hWnd && m_wndTabs.IsWindow() )
		m_wndTabs.Resize();
	if( m_pActiveView )
		m_pActiveView->MoveWindow( GetViewRect(), TRUE );
}

LRESULT CTabsOwner::OnCmdTabClose( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled )
{
    if( m_pActiveView )
        m_pActiveView->SendMessage( WM_CLOSE );
    return 0;
}

LRESULT CTabsOwner::OnCmdTabCycleNext( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled )
{
    m_wndTabs.CycleTab( true );
    return 0;
}

LRESULT CTabsOwner::OnCmdTabCyclePrev( WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled )
{
    m_wndTabs.CycleTab( false );
    return 0;
}

bool CTabsOwner::PassFocusToActiveView()
{
    if( NULL == m_pActiveView )
        return false;
    m_pActiveView->SetFocus();
    return true;
}
