#pragma once

#ifndef WINVER                // Allow use of features specific to Windows XP or later.
#define WINVER 0x0501         // Change this to the appropriate value to target other versions of Windows.
#endif

#ifndef _WIN32_WINNT          // Allow use of features specific to Windows XP or later.                   
#define _WIN32_WINNT 0x0501	  // Change this to the appropriate value to target other versions of Windows.
#endif						

#ifndef _WIN32_WINDOWS        // Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

#ifndef _WIN32_IE             // Allow use of features specific to IE 6.0 or later.
#define _WIN32_IE 0x0600      // Change this to the appropriate value to target other versions of IE.
#endif

#define WIN32_LEAN_AND_MEAN   // Exclude rarely-used stuff from Windows headers
#define NOMINMAX              // Disable win32 MIN and MAX macros: std::min and std::max from <algorithm> are better

#define OEMRESOURCE

// Windows
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include <shellapi.h>

// STL
#include <limits>
#include <algorithm>

using std::min;

// ATL
#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS	// some CString constructors will be explicit

#include <atlbase.h>
#include <atlstr.h>
#include <atlwin.h>
#include <atltypes.h>
#include <atlcoll.h>
#include <atltime.h>

// Direct3D
#ifdef _DEBUG
#define D3D_DEBUG_INFO
#endif

// The '$(DXSDK_DIR)Include' must be in "Additional include directories" compiler setting
#include <D3D9.h>
//#include <d3dx9math.h>
#include <dxerr.h>
#include <ddraw.h>

// The '$(DXSDK_DIR)Lib\x86' must be in the "Additional libraries directories" linker setting
#pragma comment( lib, "d3d9" )
#pragma comment( lib, "DxErr" )

// Misc. stuff.
#include "Assert.h"
#include "utils/MiscUtils.h"
#include "Utils/UnitTests/UnitTest.h"
#include <intrin.h>
